//
// AuthAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class AuthAPI {
    /**
     Obtain OAuth2 token

     - parameter grantType: (form)  
     - parameter username: (form)  
     - parameter password: (form)  
     - parameter scope: (form)  
     - parameter clientId: (form)  
     - parameter clientSecret: (form)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func obtainToken(grantType: String, username: String, password: String, scope: String, clientId: String, clientSecret: String, completion: @escaping ((_ data: TokenGet?,_ error: Error?) -> Void)) {
        obtainTokenWithRequestBuilder(grantType: grantType, username: username, password: password, scope: scope, clientId: clientId, clientSecret: clientSecret).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Obtain OAuth2 token
     - POST /api/v1/token

     - examples: [{contentType=application/json, example={
  "access_token" : "access_token",
  "refresh_token" : "refresh_token",
  "token_type" : "token_type",
  "expires_in" : 0
}}]
     - parameter grantType: (form)  
     - parameter username: (form)  
     - parameter password: (form)  
     - parameter scope: (form)  
     - parameter clientId: (form)  
     - parameter clientSecret: (form)  

     - returns: RequestBuilder<TokenGet> 
     */
    open class func obtainTokenWithRequestBuilder(grantType: String, username: String, password: String, scope: String, clientId: String, clientSecret: String) -> RequestBuilder<TokenGet> {
        let path = "/api/v1/token"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "grant_type": grantType,
                "username": username,
                "password": password,
                "scope": scope,
                "client_id": clientId,
                "client_secret": clientSecret
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<TokenGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Refresh OAuth2 token

     - parameter grantType: (form)  
     - parameter refreshToken: (form)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func refreshToken(grantType: String, refreshToken: String, completion: @escaping ((_ data: TokenGet?,_ error: Error?) -> Void)) {
        refreshTokenWithRequestBuilder(grantType: grantType, refreshToken: refreshToken).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Refresh OAuth2 token
     - POST /api/v1/token/refresh

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "access_token" : "access_token",
  "refresh_token" : "refresh_token",
  "token_type" : "token_type",
  "expires_in" : 0
}}]
     - parameter grantType: (form)  
     - parameter refreshToken: (form)  

     - returns: RequestBuilder<TokenGet> 
     */
    open class func refreshTokenWithRequestBuilder(grantType: String, refreshToken: String) -> RequestBuilder<TokenGet> {
        let path = "/api/v1/token/refresh"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "grant_type": grantType,
                "refresh_token": refreshToken
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<TokenGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Revoke OAuth2 token

     - parameter token: (form)  
     - parameter tokenTypeHint: (form)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func revokeToken(token: String, tokenTypeHint: TokenTypeHints, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        revokeTokenWithRequestBuilder(token: token, tokenTypeHint: tokenTypeHint).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Revoke OAuth2 token
     - POST /api/v1/token/revoke

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter token: (form)  
     - parameter tokenTypeHint: (form)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func revokeTokenWithRequestBuilder(token: String, tokenTypeHint: TokenTypeHints) -> RequestBuilder<APIResponseStatusOK> {
        let path = "/api/v1/token/revoke"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "token": token,
                "token_type_hint": tokenTypeHint
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
